/*
  Ncr4x20Vfd Library - Hello World
  
  Demonstrates use of the NCR 7454 / Futaba M204SD01B
  4x20 VFD module.
  
  This sketch prints "Hello World!" to the LCD
  and displays in seconds the amount of time the 
  sketch has been running.

  TODO: Insert link to wiring tutoral.

  Reference page:
    http://arduino.cc/playground/Main/Ncr4X20VfdHelloWorld
  
  Originally created 6 Feb 2011

  This file is in the public domain.
*/

#include <Ncr4X20Vfd.h>

// See Ncr4X20VfdTutorialPins.h for other board defines.
#define NCR_4X20_VFD_ARDUINO_PINOUT
#include "Ncr4X20TutorialPins.h"

Ncr4X20Vfd vfd(NCR_4X20_VFD_STROBE_PIN,
               NCR_4X20_VFD_BUSY_PIN,
               NCR_4X20_VFD_DATA0_PIN,
               NCR_4X20_VFD_DATA1_PIN,
               NCR_4X20_VFD_DATA2_PIN,
               NCR_4X20_VFD_DATA3_PIN,
               NCR_4X20_VFD_DATA4_PIN,
               NCR_4X20_VFD_DATA5_PIN,
               NCR_4X20_VFD_DATA6_PIN,
               NCR_4X20_VFD_DATA7_PIN);

void setup() {
  
  // Drive the unneeded control lines high. The display's parallel 
  // interface will not function correctly if they are low.
  digitalWrite(NCR_4X20_VFD_RESET_PIN, HIGH);
  digitalWrite(NCR_4X20_VFD_UNKNOWN_CONTROL1_PIN, HIGH);
  digitalWrite(NCR_4X20_VFD_UNKNOWN_CONTROL2_PIN, HIGH);
  
  pinMode(NCR_4X20_VFD_RESET_PIN, OUTPUT);
  pinMode(NCR_4X20_VFD_UNKNOWN_CONTROL1_PIN, OUTPUT);
  pinMode(NCR_4X20_VFD_UNKNOWN_CONTROL2_PIN, OUTPUT); 
  
  // Start the library.
  vfd.begin();
  
  // Print an initial message on the VFD.
  vfd.print("hello, world!");
}

void loop() {
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  vfd.setCursor(0, 1);
  // print the number of seconds since reset:
  vfd.print(millis()/1000);
  
  // We delay here. Sending data continuously with no breaks can
  // saturate the microcontroller on the display, preventing it from
  // updating it's output correctly.
  delay(10);
}

